import java.awt.EventQueue;
import java.sql.SQLException;
import java.sql.Time;
import java.text.*;

import javax.swing.Timer;
import javax.swing.JFrame;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JPanel;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import javax.swing.JTable;
import javax.swing.table.*;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import javax.swing.JPasswordField;

public class GUI {

	private JFrame frmCscFinalDb;
	private JTextField userField;
	private JPasswordField passwordField;
	private JTextField firstnameField;
	private JTextField lastnameField;
	private JTable table;
	private final int maxCourses = 6;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					GUI window = new GUI();
					window.frmCscFinalDb.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public GUI() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmCscFinalDb = new JFrame();
		frmCscFinalDb.setTitle("CSC22100 Final DB Project");
		frmCscFinalDb.setBounds(100, 100, 619, 422);
		frmCscFinalDb.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmCscFinalDb.getContentPane().setLayout(new CardLayout(0, 0));
		
		
		// instantiate all labels and fields
		JLabel lblUserName = new JLabel("User Name:");
		lblUserName.setBounds(104, 167, 69, 14);
		
		JLabel lblWelcome = new JLabel("Welcome!");
		lblWelcome.setBounds(27, 11, 156, 14);

		JLabel lblPassword = new JLabel("Password:");
		lblPassword.setBounds(204, 167, 86, 14);
		
		JLabel lblFirstName = new JLabel("First Name:");
		lblFirstName.setBounds(104, 117, 86, 14);
		
		JLabel lblLastName = new JLabel("Last Name:");
		lblLastName.setBounds(204, 117, 86, 14);
		
		JLabel lblStatus = new JLabel("");
		lblStatus.setBackground(Color.LIGHT_GRAY);
		lblStatus.setBounds(39, 237, 501, 28);
		lblStatus.setOpaque(true);
		
		JButton btnClearAllSelections = new JButton("Clear All Selections");

		btnClearAllSelections.setBounds(107, 339, 177, 23);
		
		firstnameField = new JTextField();
		firstnameField.setBounds(104, 136, 86, 20);
		
		
		lastnameField = new JTextField();
		lastnameField.setBounds(204, 134, 86, 20);
		
		userField = new JTextField();
		userField.setBounds(104, 183, 86, 20);
		
		passwordField = new JPasswordField();
		passwordField.setBounds(203, 183, 87, 20);;
		
		JPanel panel_Login = new JPanel();
		frmCscFinalDb.getContentPane().add(panel_Login, "name_17607435802129");
		panel_Login.setLayout(null);	
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(107, 36, 441, 292);
		
		// creating the title menu of the table
		DefaultTableModel tablemodel = new DefaultTableModel();
		tablemodel.addColumn("ID");
		tablemodel.addColumn("COURSE NAME");
		tablemodel.addColumn("DAY");
		tablemodel.addColumn("START TIME");
		tablemodel.addColumn("END TIME");
		table = new JTable(tablemodel) {	// this overrides the method for multiple row selection & row deselection
											// without which unselect feature is not easily accomplished
			@Override
			public void changeSelection(int rowIndex, int columnIndex, boolean toggle, boolean extend) {
				super.changeSelection(rowIndex, columnIndex, true, false);
			}
		};

		table.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		scrollPane.setViewportView(table);
		
		
		ListSelectionModel model = table.getSelectionModel();
		
		// This prevent mousedrag to select multiple rows, which is bad for the purpose of this project (will exceed maxCourses)
		table.addMouseMotionListener(new MouseMotionAdapter() {
			@Override
			public void mouseDragged(MouseEvent arg0) {
				int currentRow = table.rowAtPoint(arg0.getPoint());
				model.removeSelectionInterval(currentRow, currentRow);
			}
		});
		
	
		
		table.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				int currentRow = table.rowAtPoint(arg0.getPoint());
				
				// restrict max course selections
				if (table.getSelectedRowCount() > maxCourses) {
					model.removeSelectionInterval(currentRow,currentRow);
					JOptionPane.showMessageDialog(null, "You have selected maximum number of allowed courses!");
				}
				// avoid conflicting schedules
				else if (table.isRowSelected(currentRow)) {
					try {		// create Time type variables for comparison
						SimpleDateFormat sdf = new SimpleDateFormat("hh:mm a");
						java.sql.Time curST = new Time(sdf.parse(table.getValueAt(currentRow, 3).toString()).getTime());
						java.sql.Time curET = new Time(sdf.parse(table.getValueAt(currentRow, 4).toString()).getTime());
						String curDay = table.getValueAt(currentRow, 2).toString();
						
						int compareRow;
						java.sql.Time compareST;
						java.sql.Time compareET;
						String compareDay;
						ListenerTimer lt;

						// applying concept similar to Scheduler class, but not using Scheduler class to speed things up. Using
						// data straight from the table.
						for (int i = 0; i < table.getSelectedRows().length; i++) {
							compareRow = table.getSelectedRows()[i];
							compareDay = table.getValueAt(compareRow, 2).toString();
							compareST = new Time(sdf.parse(table.getValueAt(compareRow, 3).toString()).getTime());
							compareET = new Time(sdf.parse(table.getValueAt(compareRow, 4).toString()).getTime());
							if (currentRow != compareRow && curDay.equals(compareDay) && curST.before(compareET) && curET.after(compareST)) {
								lt = new ListenerTimer(currentRow, compareRow, model);
								JOptionPane.showMessageDialog(null, "Course ID " + table.getValueAt(currentRow, 0) + " has a schedule conflict with course ID " + table.getValueAt(compareRow, 0));
								model.removeSelectionInterval(currentRow, currentRow);
								break;
							}
						}
						
					} catch (Exception a) {
						a.printStackTrace();
					}
					
					
					
				}
			}
		});
		
		btnClearAllSelections.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				table.clearSelection();
			}
		});
		
			
		JPanel panel_Scheduler = new JPanel();
		panel_Scheduler.addComponentListener(new ComponentAdapter() {
			@Override
			public void componentShown(ComponentEvent arg0) {
				// delete/reset table rows each time a new login is succesfully initiated
				int tcount = table.getRowCount();
				for (int i = 0; i < tcount; i++) {
					tablemodel.removeRow(0);;
				}
				
				
				// get First name of user
				Scheduler scheduler = new Scheduler();
				lblWelcome.setText("Welcome, " + scheduler.getFName(userField.getText()) + "!");

				// connecting to database
				DB db = new DB();
				
				
				// populate table with data
				String[] row = new String[5];
				String sql = "Select * FROM COURSES ORDER BY COURSENAME;";
				try {
					db.rs = db.s.executeQuery(sql);
					while (db.rs.next()) {
						row[0] = db.rs.getString("ID");
						row[1] = db.rs.getString("COURSENAME");
						row[2] = db.rs.getString("DAYS");
						row[3] = String.format("%1$tR %1$Tp",db.rs.getTime("STARTTIME"));
						row[4] = String.format("%1$tR %1$Tp",db.rs.getTime("ENDTIME"));
						tablemodel.addRow(row);
					}	
				} catch (SQLException e) {
					e.printStackTrace();
				}
				
				db.closeconnection();	// close database connection
			}
		});
		frmCscFinalDb.getContentPane().add(panel_Scheduler, "name_17611359671469");
		panel_Scheduler.setLayout(null);
		

		panel_Scheduler.add(lblWelcome);
		
		panel_Scheduler.add(scrollPane);
		

		panel_Scheduler.add(btnClearAllSelections);
		
		
		// loging out, reset fields to blank
		JButton btnLogout = new JButton("Logout");
		btnLogout.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				firstnameField.setText("");
				lastnameField.setText("");
				userField.setText("");
				passwordField.setText("");
				panel_Scheduler.setVisible(false);
				panel_Login.setVisible(true);
			}
		});
		btnLogout.setBounds(459, 339, 89, 23);
		panel_Scheduler.add(btnLogout);
		
		panel_Scheduler.setVisible(false);
		
		panel_Login.add(lblUserName);
		
		panel_Login.add(lblPassword);
		
		panel_Login.add(firstnameField);
		
		panel_Login.add(lastnameField);
		
		panel_Login.add(passwordField);
		
		panel_Login.add(userField);
		userField.setColumns(10);
		
		panel_Login.add(lblFirstName);
		
		panel_Login.add(lblLastName);
		
		panel_Login.add(lblStatus);
		
		// using Scheduler class and concept to register user
		JButton btnRegister = new JButton("Register");
		btnRegister.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (firstnameField.getText().isEmpty() || lastnameField.getText().isEmpty() || userField.getText().isEmpty() || new String(passwordField.getPassword()).isEmpty()) {
					lblStatus.setText("First Name, Last Name, Username or Password fields cannot be blank!");
				}
				else if (userField.getText().contains(" ")) {
					lblStatus.setText("Invalid Username. Please use only alphanumeric characters for your username");
				}
				else {
					Scheduler scheduler = new Scheduler();
					if (!scheduler.registerUser(userField.getText(), firstnameField.getText(), lastnameField.getText(), new String(passwordField.getPassword()).toString())) {
						lblStatus.setText("This username has already been taken! Please Try again!");
					}
					else {
						lblStatus.setText("");
						panel_Login.setVisible(false);
						panel_Scheduler.setVisible(true);
					}
					
				}
			}
		});
		btnRegister.setBounds(312, 133, 89, 23);
		panel_Login.add(btnRegister);
		
		// login feature, using Scheduler class and concept
		JButton btnLogin = new JButton("Login");
		btnLogin.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				lblStatus.setText("Logging in...");
				Scheduler scheduler = new Scheduler();
				if (scheduler.loginUser(userField.getText(), new String(passwordField.getPassword()))) {
					lblStatus.setText("");
					panel_Login.setVisible(false);
					panel_Scheduler.setVisible(true);
				}
				else {
					lblStatus.setText("Login Failed!");
					userField.setText("");
					passwordField.setText("");
				}
			}
		});
		btnLogin.setBounds(312, 182, 89, 23);
		panel_Login.add(btnLogin);		
		

	}
}



// interface created for passing values into Timer - to achieve blinking effect on rows
// when conflict of schedules occur.
class ListenerTimer implements ActionListener {
	ListSelectionModel model;
	private int blinkRow1 = -1;		// the two conflicting rows (current row)
	private int blinkRow2 = -1;		// conflicted row
	private int count = 0;
	private int maxCount = 10;		// count to maxCount for blinking/flashes the row (by means of repeated select/deselect in actionPerformed())
	
	ListenerTimer(int row1, int row2, ListSelectionModel lsm) {
		model = lsm;
		blinkRow1 = row1;	// current row
		blinkRow2 = row2;	// conflicted row
		Timer RowTimer = new Timer(100,this);
		RowTimer.start();
	}
	
	// blinking effect
	public void actionPerformed(ActionEvent e) {
		if (count >= maxCount) {
			model.removeSelectionInterval(blinkRow1, blinkRow1);
			model.addSelectionInterval(blinkRow2, blinkRow2);
			((Timer)e.getSource()).stop();
		}
		else if (model.isSelectedIndex(blinkRow1)) {
			model.removeSelectionInterval(blinkRow1, blinkRow1);
			model.removeSelectionInterval(blinkRow2, blinkRow2);
		}
		else {
			model.addSelectionInterval(blinkRow1, blinkRow1);
			model.addSelectionInterval(blinkRow2, blinkRow2);
		}
		count++;
	}

}
